/**
 * An employee social-security number object. Allows creation, validation, and
 * ordering of employee SS #'s.
 */

public class SSN
{
	String val;
	final static int MAX_LENGTH = 11;

	SSN(String s)
	{
		val = s;
	}

	String value()
	{
		return val;
	}

	public boolean isValid()
	{
		if (val.length() > MAX_LENGTH) return false;
		if (val.charAt(3) != '-') return false;
		if (val.charAt(6) != '-') return false;
		try
		{
			Integer.parseInt(val.substring(0, 2));
			Integer.parseInt(val.substring(4, 5));
			Integer.parseInt(val.substring(7, 10));
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		return true;
	}

	public boolean isGreaterThan(SSN s)
	{
		return val.compareTo(s.val) > 0;
	}
}

